using System;


using Syncfusion;
using System.Drawing;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Diagram;
using Syncfusion.Windows.Forms.Diagram.Controls;
using System.Runtime.Serialization;
using Symcon.LightRidge.BusinessObjects;
using Symcon.LightRidge.BusinessObjects.Utilities;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using PerpetuumSoft.Framework.Model;


namespace Symcon.Lightridge.LRRUI.Controls
{
	/// <summary>
	/// Summary description for MyLabels.
	/// </summary>
	[Serializable()]
	public class LRRLabel :Syncfusion.Windows.Forms.Diagram.Label
	{
		public LRRLabel()
		{
			_isCreated = true;
			this.WrapText = true;
			this.Visible = false;
			this.ReadOnly = true;
			this.Name =Guid.NewGuid().ToString();
            //this.GetStringFormat().Trimming = StringTrimming.EllipsisCharacter;
            this.FontStyle.Family = "Arial";

		}

		/// <summary>
		/// Copy constructor.
		/// </summary>
		/// <param name="src"></param>
		public LRRLabel(LRRLabel src) : base(src)
		{
			LRRLabel lblSource = src as LRRLabel;
			LRRLabel lblTarget = this;	  
			lblTarget._isCreated = true;
			lblTarget.IsCompare1 = false;
			lblTarget.IsCompare2 = false;
			lblTarget.IsRefrence = false;
			//lblTarget.LabelColorCode = ErrorCode.NONE;
			lblTarget.ParentID = "";
			lblTarget.IsParent = false;
			lblTarget.Grouped = true;
			lblTarget.Tag = null;
			lblTarget.IsUOM = false;
			
			this.Name = Guid.NewGuid().ToString();
			lblTarget.Text = null;
			
			//lblTarget.Width = src.Width;
			//lblTarget.width = src.Width;

		}



		/// <summary>
		/// Serialization constructor for the MySymbol class.
		/// </summary>
		/// <param name="info">Serialization state information</param>
		/// <param name="context">Streaming context information</param>
		protected LRRLabel(SerializationInfo info, StreamingContext context) : base(info, context)
		{
		// The Serialization constructor is invoked during deserialization or during a drag & drop operation.
		// If the MySymbol type has serializable members, then initialize them with the serialized data 
		// obtained from the SerializationInfo param
			try
			{
				this._id = (string) info.GetString("_id");
				this._isCreated  = (bool) info.GetBoolean("_isCreated");
				this._isParent  = (bool) info.GetBoolean("_isParent");
				this._isParentLabel= (bool) info.GetBoolean("_isParentLabel");
				//this._labelColorCode = (ErrorCode) info.GetValue("_labelColorCode",typeof(ErrorCode));
				this._parentID= (string) info.GetString("_parentID");
				this.isUOM= (bool) info.GetBoolean("isUOM");
				this.isCompare1= (bool) info.GetBoolean("isCompare1");
				this.isCompare2= (bool) info.GetBoolean("isCompare2");
				this.isRef = (bool) info.GetBoolean("isRef");
			}
			catch
			{

			}
			//this._tag = (string) info.GetValue("_tag",typeof(object));
		}

		public override object Clone()
		{
			return new LRRLabel(this);
		}

		protected override void GetObjectData(SerializationInfo info, StreamingContext context)
		{
			base.GetObjectData (info, context);
			info.AddValue("_id", this._id);
			info.AddValue("_isCreated", this._isCreated);
			info.AddValue("_isParent", this._isParent);
			info.AddValue("_isParentLabel", this._isParentLabel);
			info.AddValue("_labelColorCode", this._labelColorCode);
			info.AddValue("_parentID", this._parentID);
			info.AddValue("isUOM", this.isUOM);
			info.AddValue("isCompare1", this.isCompare1);
			info.AddValue("isCompare2", this.isCompare2);
			info.AddValue("isRef", this.isRef);



			//info.AddValue("_tag", this._tag);
		}




		#region Fields

		private string _id = "";
		private string _parentID = "";
		private bool _isParent = true; 
		private bool _isCreated;
		private float width =100;
		private object _tag;
		//public event Symcon.LightRidge.BusinessObjects.PropertyChanged	UOMChanged;
		//public event Symcon.LightRidge.BusinessObjects.PropertyChanged	TextChanged;
		public event NodeMouseEventHandler LabelDoubleClick;
		private ErrorCode _labelColorCode;
		//private ErrorCode _labelBackColorCode;




		[NonSerialized()]
		bool isCompare1;

		[NonSerialized()]
		bool isCompare2;

		[NonSerialized()]
		bool isRef;

		[NonSerialized()]
		bool isUOM = false;


		[NonSerialized()]
		bool _isParentLabel;
		#endregion

		[Browsable(false)]
		public string ID
		{
			get{return _id;}
			set
			{
				_id = value;
			}
		}

		[Browsable(false)]
		public string ParentID
		{
			get{return _parentID;}
			set{_parentID = value;}
		}

		[Browsable(true),DefaultValue(true)]
		public bool Grouped
		{
			get
			{
				return _isParent;
			}
			set
			{
				_isParent = value;
			}
		}



		[Browsable(false)]
		public bool CreatedFlag
		{
			get
			{
				return _isCreated;
			}
		}


		[Browsable(false)]
		public object Tag
		{
			get
			{
				return _tag;
			}
			set
			{
				_tag = value;
			}
		}

	
		[Browsable(true),ReadOnly(true)]
		public new string Text
		{
			get
			{
				return base.Text;
			}

			set
			{
                
				if(base.Text != value)
				{
					base.Text = value;
				}
			}
		}

		[Browsable(false)]
		public new string Name
		{
			get
			{
				return base.Name;
			}

			set
			{
				base.Name = value;
			}
		}


		[Browsable(false)]
		public new float OffsetX
		{
			get
			{
				return base.OffsetX;
			}

			set
			{
				base.OffsetX = value;
			}
		}


		[Browsable(false)]
		public new float OffsetY
		{
			get
			{
				return base.OffsetY;
			}

			set
			{
				base.OffsetY = value;
			}
		}


		[Browsable(false)]
		public new Position Anchor
		{
			get
			{
				return base.Position;
			}

			set
			{
				base.Position = value;
			}
		}


		[Browsable(false)]
		public new LabelPropertyBinding PropertyBinding
		{
			get
			{
				return base.PropertyBinding;
			}

			set
			{
				base.PropertyBinding = value;
			}
		}



		[Browsable(false)]
		public bool IsUOM
		{
			get
			{
				return isUOM;
			}

			set
			{
				isUOM = value;
			}
		}

		[Browsable(false)]
		public bool IsCompare1
		{
			get
			{
				return isCompare1;
			}

			set
			{
				isCompare2 = false;
				isRef = false;
				isCompare1 = value;
			}
		}

		[Browsable(false)]
		public bool IsCompare2
		{
			get
			{
				return isCompare2;
			}

			set
			{
				isCompare1 = false;
				isRef  = false;
				isCompare2 = value;
			}
		}

		[Browsable(false)]
		public bool IsRefrence
		{
			get
			{
				return isRef;
			}

			set
			{
				isCompare1 = false;
				isCompare2 = false;
				isRef = value;
			}
		}


		[Browsable(false)]
		public bool IsParent
		{
			get
			{
				return _isParentLabel;
			}

			set
			{
				_isParentLabel = value;
			}
		}

		[Browsable(false)]
		public ErrorCode LabelColorCode
		{
			get
			{
				return _labelColorCode;
			}
			set
			{
				_labelColorCode = value;

			}
		}


		/*protected override void OnPropertyChanged(PropertyEventArgs evtArgs)
		{
			if(evtArgs.PropertyName == "Text")
			{
				base.OnPropertyChanged (evtArgs);
				this.Width = width;
				Symbol smbl =  this.Parent as Symbol;
				if(smbl != null)
				{
					PropertyTable myPT =  smbl.GetPropertyValue("PT") as PropertyTable;
					if(myPT != null)
					{
						for(int i= myPT.Properties.Count; i>0;i--)
						{
							PropertySpec ps =  myPT.Properties[i-1] as PropertySpec;
							if(ps.Category == "Bound Properties")
							{
								if(ps.ObjectRef.ToString() == this.ParentID)
								{
									if(smbl.Labels[ps.Name] != null) 
									{
										ps.DefaultValue = smbl.Labels[ps.Name].Text;
									}
								}
							}
						}
					}
				}
			}
			else
			{
				base.OnPropertyChanged (evtArgs);
			}
		}*/

		/*protected override void OnPropertyChanging(PropertyEventArgs evtArgs)
		{
			if(evtArgs.PropertyName == "Text")
			{
				if (this.Width != 0)
				{
					width = this.Width;
				}
				
				base.OnPropertyChanged (evtArgs);
				if(evtArgs.NewValue ==  null || evtArgs.NewValue.ToString().Trim() == "")
				{
					//this.Visible = false;
				}
				else
				{
					//this.Visible = true;
				}
			}
			else
			{
				base.OnPropertyChanged (evtArgs);
			}
		}*/
	
		/*protected override void OnDoubleClick(NodeMouseEventArgs evtArgs)
		{
			base.OnDoubleClick (evtArgs);
//			if(this.ID != null)
//			{
//				LRRUOMType lrrUOMType = LRRModel.ChildModel.UomTypes.GetUOMTypeObjectFromID(this.ID);
//				if(lrrUOMType != null && this.Tag != null && this.Tag.GetType() == typeof(LRRUOM))
//				{
//					string selectedUOMID = LRRModel.ChildModel.GetUOMIDFromName(this.Text);
//
//					Symbol smbl = this.Parent as Symbol;
//				
//					string propName = null;
//					propName = smbl.GetPropertyValue("SiteItem").ToString();
//					propName = propName + ":  " + this.Name.Substring(this.Name.LastIndexOf("-")+1);
//
//					if(propName == null)
//						propName = "";
//
//					UOMChangeDialog uomChangeDialog = new UOMChangeDialog(lrrUOMType,selectedUOMID,propName);
//					
//					if( uomChangeDialog.ShowDialog() ==  DialogResult.OK)
//					{
//						if(UOMChanged!= null)
//						{
//						
//							UOMChanged(this,uomChangeDialog.SelectedUOMID);
//						}
//					}
//				}
//				else
//				{
			
					if(LabelDoubleClick != null)
					{
						LabelDoubleClick(this,evtArgs);
					}
//				}
//			}
		}*/

        /*protected override void OnMove(MoveEventArgs evtArgs)
        {
            if(this.Grouped)
            {
                if(this.Parent != null &&this.Parent.GetType().BaseType == typeof(Symbol))
                {
                    Symbol smbl =  this.Parent as Symbol;
                    foreach(LRRLabel lbl in smbl.Labels)
                    {
                        if(lbl != this && this.ParentID == lbl.ParentID && this.ParentID != null && this.ParentID.Trim() != "")
                        {
                            lbl.OffsetX = lbl.OffsetX + evtArgs.OffsetX;
                            lbl.OffsetY = lbl.OffsetY + evtArgs.OffsetY;
                        }
                    }
                }
            }
            base.OnMove (evtArgs);
        }*/
        /*public override void Draw(Graphics grfx)
        {
            StringFormat fmt = this.GetStringFormat();
            if (this.Visible)
            {
                Matrix worldXform;
                if (this.Container != null)
                {
                    worldXform = this.Container.GetLabelTransform(this.matrix);
                }
                else
                {
                    worldXform = this.matrix;
                }

                RectangleF bounds = this.GetTextBox();
                Matrix prevXform = grfx.Transform;

                grfx.Transform = worldXform;
                grfx.MultiplyTransform(Global.ViewMatrix, MatrixOrder.Append);

                Brush backgroundBrush = this.BackgroundStyle.CreateBrush();
                grfx.FillRectangle(backgroundBrush, bounds.Left, bounds.Top, bounds.Width, bounds.Height);
                backgroundBrush.Dispose();

                Font font = this.FontStyle.CreateFont();
                Brush fillBrush = this.FillStyle.CreateBrush();
                fmt.Trimming = StringTrimming.EllipsisCharacter;
                grfx.DrawString(this.Text, font, fillBrush, bounds, fmt);
                font.Dispose();
                fillBrush.Dispose();

                if (this.BorderStyle.ShowBorder)
                {
                    Pen pen = this.BorderStyle.CreatePen();
                    grfx.DrawRectangle(pen, bounds.Left, bounds.Top, bounds.Width, bounds.Height);
                    pen.Dispose();
                }

                grfx.Transform = prevXform;
            }
        }*/
	}
}