using System;
using System.ComponentModel;
using System.Globalization;
using System.Runtime.Serialization;
using System.Windows.Forms;
using System.Diagnostics;
using System.Collections;
using System.Reflection;
using System.Xml.Serialization;
using System.Drawing;

using Symcon.LightRidge.BusinessObjects.TypeConverters;

using Syncfusion.Windows.Forms.Diagram;
using Syncfusion.Windows.Forms.Diagram.Controls;
using System.Drawing.Drawing2D;
namespace Symcon.Lightridge.LRRUI.Controls
{
	public class SymbolsUtils 
	{
		static SymbolsUtils()
		{
			
		}

		public static void CreateLabels(PathNode mysymbol)
		{
			CreateHeader(mysymbol);

			int	count =	0;
			int	_maxRow	= 3;
			int	_maxCol	= 3;
			for(int m=0;m<4;m++)
			{
				for	(int i = 0;	i <	_maxRow; i++)
				{
					for	(int j = 0;	j <	_maxCol; j++)
					{		
						string str = (string)i.ToString(Symcon.BusinessObjects.SymConverter.Culture) +	j.ToString(Symcon.BusinessObjects.SymConverter.Culture);
						//-------------------------------------------------
						//|	00(Nothing)		01(PropValue 1)		02(Nothing)
						//|	10(PropName)	11(PropValue 2)		12(UOM)
						//|	20(Property	Description)		21(PropValue 3)		22(Nothing)
						//-------------------------------------------------
				
						switch(str)
						{
							case "00":
							{
								break;
							}
							case "01":
							{
								LRRLabel smblLbl = new LRRLabel();
								smblLbl.Anchor = Position.TopLeft;
								smblLbl.OffsetX	= -40;
								smblLbl.OffsetY	= (count + (count *	45)) ;
								smblLbl.HorizontalAlignment	= StringAlignment.Far;
								mysymbol.Labels.Add(smblLbl);
								InitLabelLookFeel(smblLbl);
								break;
							}

							case "02":
							{
								LRRLabel smblLbl = new LRRLabel();
								smblLbl.Anchor = Position.TopLeft;
								smblLbl.OffsetX	= -10;
								smblLbl.OffsetY	= (count + (count *	45)) ;
								smblLbl.HorizontalAlignment	= StringAlignment.Far;
								mysymbol.Labels.Add(smblLbl);
								
								InitLabelLookFeel(smblLbl);
                                //smblLbl.Width = 10;
                                //smblLbl.Height = 10;
                                //smblLbl.EditStyle.Enabled = true;
                                //smblLbl.EditStyle.AllowResize = false; 
								break;
							}
							case "10":
							{
								LRRLabel smblLbl = new LRRLabel();
								smblLbl.Anchor = Position.TopLeft;
								smblLbl.OffsetX	= -80;
								smblLbl.OffsetY	= (count	+ (count * 45))+15;
								smblLbl.HorizontalAlignment	= StringAlignment.Far;
								mysymbol.Labels.Add(smblLbl);
								InitLabelLookFeel(smblLbl);
								break;
							}
							case "11":
							{
								LRRLabel smblLbl = new LRRLabel();
								smblLbl.Anchor = Position.TopLeft;
								smblLbl.OffsetX	= -40;
								smblLbl.OffsetY	= (count	+ (count * 45))+15;
								smblLbl.HorizontalAlignment	= StringAlignment.Far;
								mysymbol.Labels.Add(smblLbl);
								InitLabelLookFeel(smblLbl);
								break;
							}
							case "12":
							{
								LRRLabel smblLbl = new LRRLabel();
								smblLbl.Anchor = Position.TopLeft;
								smblLbl.OffsetX	= -10;
								smblLbl.OffsetY	= (count	+ (count * 45))+15;
								smblLbl.HorizontalAlignment	= StringAlignment.Near;
								mysymbol.Labels.Add(smblLbl);
								InitLabelLookFeel(smblLbl);
								//smblLbl.Width = 20;
								break;
							}
							case "21":
							{
								LRRLabel smblLbl = new LRRLabel();
								smblLbl.Anchor = Position.TopLeft;
								smblLbl.OffsetX	= -40;
								smblLbl.OffsetY	= (count + (count *	45)) + 30;
								smblLbl.HorizontalAlignment	= StringAlignment.Far;
								mysymbol.Labels.Add(smblLbl);
								InitLabelLookFeel(smblLbl);
								break;
							}
							case "22":
							{
								LRRLabel smblLbl = new LRRLabel();
								smblLbl.Anchor = Position.TopLeft;
								smblLbl.OffsetX	= -10;
								smblLbl.OffsetY	= (count + (count *	45))+ 30 ;
								smblLbl.HorizontalAlignment	= StringAlignment.Far;
								mysymbol.Labels.Add(smblLbl);
								
								InitLabelLookFeel(smblLbl);
                                //smblLbl.Width = 10;
                                //smblLbl.Height = 10;
                                //smblLbl.EditStyle.Enabled = true;
                                //smblLbl.EditStyle.AllowResize = false; 
								break;
							}
							default:
							{
								break;
							}
						}			
					}
				}
				count++;
			}
			CreateLinkLabel(mysymbol);

		}

		private static void CreateHeader(PathNode mySymbol)
		{
			//Set the Header Label
			LRRLabel hsmblLbl = new LRRLabel();
			hsmblLbl.Anchor	= Position.TopLeft;
			hsmblLbl.OffsetY = -15;
			hsmblLbl.HorizontalAlignment = StringAlignment.Center;
			hsmblLbl.VerticalAlignment = StringAlignment.Center;
			mySymbol.Labels.Add(hsmblLbl);
			InitLabelLookFeel(hsmblLbl);
			hsmblLbl.BackgroundStyle.Color = ((FilledPath)mySymbol).FillStyle.Color;
			hsmblLbl.OffsetX = -60;
            //hsmblLbl.Width = 100;
		}

		private static void CreateLinkLabel(PathNode mySymbol)
		{
			LRRLabel smblLbl = new LRRLabel();
			//InitLabelLookFeel(smblLbl);
			smblLbl.Anchor = Position.Center;
			smblLbl.Text = "Link";
			smblLbl.Name = "Link";
			smblLbl.Visible = false;
			smblLbl.HorizontalAlignment	= StringAlignment.Near;
			mySymbol.Labels.Add(smblLbl);
		}

		private static void	InitLabelLookFeel(Syncfusion.Windows.Forms.Diagram.Label lbl)
		{
			lbl.BackgroundStyle.Color = Color.Transparent;
			lbl.FontStyle.Name = "Arial";
			lbl.FontStyle.Family = "Arial";
			lbl.FontStyle.PointSize = 9f;
			//lbl.EditStyle.Enabled = true;
			lbl.WrapText = false;
			lbl.NoClip = false;
			///lbl.Width = 40f;
			//lbl.Height = 15;
		}
	}
}
