using System;
using Syncfusion.Windows.Forms.Diagram;
using System.Drawing;
using System.Runtime.Serialization;
using System.Drawing.Drawing2D;
using System.ComponentModel;
using PerpetuumSoft.Framework.Model;

//using Syncfusion.Windows.Forms.Design;

namespace Symcon.Lightridge.LRRUI.Controls.Tools
{
	[Serializable]
	public class OrthogonalLink : OrthogonalConnector
	{
		#region		
		private OrthogonalConnector _line;
		#endregion

        public OrthogonalLink(PointF ptStart, PointF ptEnd)
            : base(ptStart, ptEnd)
        {
        }

        public OrthogonalLink(PointF[] pts)
            : base(pts[0], pts[pts.Length - 1])
        {
        }

		
		/// <summary>
		/// Copy constructor.
		/// </summary>
		/// <param name="src"></param>
        public OrthogonalLink(OrthogonalLink src)
            : base(src)
        {

        }

		/// <summary>
		/// Serialization constructor for symbols.
		/// </summary>
		/// <param name="info">Serialization state information.</param>
		/// <param name="context">Streaming context information.</param>
        protected OrthogonalLink(SerializationInfo info, StreamingContext context)
            : base(info, context)
        {
        }


		/// <summary>
		/// Creates a new object that is a copy of the current instance.
		/// </summary>
		/// <returns>Copy of the object this method is invoked against</returns>
		public override object Clone()
		{
			return new OrthogonalLink(this);
		}

        /* CreateLinkShape method is no longer available. We suggest you to use the 
         * CreateLogicalGraphicsPath instead of that method*/
        protected override GraphicsPath CreateLogicalGraphicsPath(PointF[] pts)
        {
            return base.CreateLogicalGraphicsPath(pts);
        }

        //protected override IPoints CreateLinkShape(Syncfusion.Windows.Forms.Diagram.Link shapeType, PointF[] pts)
        //{
        //    //Shape linkShape	= null;
        //    try
        //    {
				
        //        _line =	new	OrthogonalConnector(pts[0], pts[pts.Length-1]);
				
        //        linkShape =	_line;
        //        if(linkShape !=	null)
        //        {
        //            linkShape.SetPoints(pts);
        //        }

        //    }
        //    catch(Exception ex)
        //    {
        //        string msg = ex.Message;
        //    }
        //    return linkShape;
        //}

		protected override void GetObjectData(SerializationInfo info, StreamingContext context)
		{
			base.GetObjectData(info, context);
		}

		#region Properties
        /* Decorators are read only properties. We cannot assign value to it. We suggest you to use the decoratorShape property of decorator
         * in order to assign different decorator shapes*/

        //[Category("LineCap"),Editor(typeof(Syncfusion.Windows.Forms.Diagram.EndPointDecoratorEditor),typeof(System.Drawing.Design.UITypeEditor)),TypeConverter(typeof(EndPointDecoratorConverter))]
        //public EndPointDecorator EndCap
        //{
        //    get
        //    {
        //        return this.EndPoints.LastEndPointDecorator;
        //    }
        //    set
        //    {
        //        this.EndPoints.LastEndPointDecorator = value;
        //        if(this.EndPoints.LastEndPointDecorator != null)
        //        {
        //            //this.EndPoints.LastEndPointDecorator.LineStyle.LineColor = this.LineStyle.LineColor;
        //            this.EndPoints.LastEndPointDecorator.FillStyle.Color = this.LineStyle.LineColor;
        //        }
        //    }
        //}


        //[Category("LineCap"), Editor(typeof(Syncfusion.Windows.Forms.Diagram.EndPointDecoratorEditor),typeof(System.Drawing.Design.UITypeEditor)),TypeConverter(typeof(EndPointDecoratorConverter))]
        //public Decorator StartCap
        //{
        //    get
        //    {
        //        return this.TailDecorator;
        //    }
        //    set
        //    {
        //        this.TailDecorator = value;
        //        if(this.TailDecorator != null)
        //        {
        //            //this.EndPoints.LastEndPointDecorator.LineStyle.LineColor = this.LineStyle.LineColor;
        //            this.TailDecorator.FillStyle.Color = this.LineStyle.LineColor;
        //        }
        //    }
        //}



		

		[Category("LineCap"),TypeConverter(typeof(SizeConverter))]
		public Size EndCapSize
		{
			get
			{
				if(this.HeadDecorator != null)
                    return this.HeadDecorator.Size.ToSize();
				else 
					return new Size(0,0);

			}
			set
			{
                this.HeadDecorator.Size = value;
			}
		}


		[Category("LineCap"),DefaultValue(typeof(Size),null),TypeConverter(typeof(SizeConverter))]
		public Size StartCapSize
		{
			get
			{
                if (this.TailDecorator != null)
                    return this.TailDecorator.Size.ToSize();
				else 
					return new Size(0,0);
			}
			set
			{
                this.TailDecorator.Size = value;
			}
		}

		[Category("LineCap")]
		public FillStyle StartCapFillStyle
		{
			get
			{
                if (this.TailDecorator != null)
                    return this.TailDecorator.FillStyle;
				else 
					return null;
			}
		}

		[Category("LineCap")]
		public FillStyle EndCapFillStyle
		{
			get
			{
                if (this.HeadDecorator != null)
                    return this.HeadDecorator.FillStyle;
				else 
					return null;
			}
		}

		[Category("LineCap")]
		public LineStyle EndCapLineStyle
		{
			get
			{
                if (this.HeadDecorator != null)
                    return this.HeadDecorator.LineStyle;
				else 
					return null;
			}
		}


	
		[Category("LineCap")]
		public LineStyle StartCapLineStyle
		{
			get
			{
                if (this.TailDecorator != null)
                    return this.TailDecorator.LineStyle;
				else 
					return null;
			}
		}

		#endregion

		#region Overrides
        public override void OnPropertyChanged(string strPropertyContainerName, string strPropertyName)
        {
            base.OnPropertyChanged(strPropertyContainerName, strPropertyName);
            if (strPropertyName == "LineColor")
            {
                if (this.HeadDecorator != null)
                {
                    this.HeadDecorator.LineStyle.LineColor = this.LineStyle.LineColor;
                    this.HeadDecorator.FillStyle.Color = this.LineStyle.LineColor;
                }
                if (this.TailDecorator != null)
                {
                    this.TailDecorator.LineStyle.LineColor = this.LineStyle.LineColor;
                    this.TailDecorator.FillStyle.Color = this.LineStyle.LineColor;
                }
            }
        }
        //protected override void OnPropertyChanged(PropertyEventArgs evtArgs)
        //{
        //    base.OnPropertyChanged (evtArgs);
        //    if(evtArgs.PropertyName == "LineColor")
        //    {
        //        if(this.HeadDecorator != null)
        //        {
        //            this.HeadDecorator.LineStyle.LineColor = (Color)evtArgs.NewValue;
        //            this.HeadDecorator.FillStyle.Color = (Color)evtArgs.NewValue;
        //        }
        //        if(this.TailDecorator != null)
        //        {
        //            this.TailDecorator.LineStyle.LineColor = (Color)evtArgs.NewValue;
        //            this.TailDecorator.FillStyle.Color = (Color)evtArgs.NewValue;
        //        }
        //    }
			
        //}

		#endregion 

	}
}
